import * as React from 'react';
import { AutoLayoutProps, BorderProps, CornerProps, DefaultContainerProps, DefaultShapeProps, FrameSpecificProps, SelectionEventProps, StyleOf } from '../../types';
import { LayoutStyleProperties } from '../../styleTransformers/transformLayoutStyleProperties';
import { BlendStyleProperties } from '../../styleTransformers/transformBlendProperties';
import { GeometryStyleProperties } from '../../styleTransformers/transformGeometryStyleProperties';
import { YogaStyleProperties } from '../../yoga/YogaStyleProperties';
import { BorderStyleProperties } from '../../styleTransformers/transformBorderProperties';
import { OnLayoutHandlerProps } from '../../hooks/useOnLayoutHandler';
export interface ComponentProps extends DefaultShapeProps, DefaultContainerProps, SelectionEventProps, AutoLayoutProps, BorderProps, CornerProps, FrameSpecificProps, OnLayoutHandlerProps {
    style?: StyleOf<GeometryStyleProperties & YogaStyleProperties & LayoutStyleProperties & BlendStyleProperties & BorderStyleProperties>;
    nodeRef?: any;
}
declare const Component: React.FC<ComponentProps>;
export { Component };
