"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var transformLayoutStyleProperties_1 = require("../../styleTransformers/transformLayoutStyleProperties");
var useYogaLayout_1 = require("../../hooks/useYogaLayout");
var __1 = require("../..");
var useSelectionChange_1 = require("../../hooks/useSelectionChange");
var transformAutoLayoutToYoga_1 = require("../../styleTransformers/transformAutoLayoutToYoga");
var useOnLayoutHandler_1 = require("../../hooks/useOnLayoutHandler");
var ComponentSet = function (props) {
    var nodeRef = props.nodeRef || React.useRef();
    useSelectionChange_1.useSelectionChange(nodeRef, props);
    var style = __assign({}, __1.StyleSheet.flatten(props.style), transformAutoLayoutToYoga_1.transformAutoLayoutToYoga(props));
    var componentProps = __assign({}, transformLayoutStyleProperties_1.transformLayoutStyleProperties(style), props, { style: style });
    var yogaChildProps = useYogaLayout_1.useYogaLayout(__assign({ nodeRef: nodeRef }, componentProps));
    useOnLayoutHandler_1.useOnLayoutHandler(yogaChildProps, props);
    return React.createElement("componentset", __assign({}, componentProps, yogaChildProps, { innerRef: nodeRef }));
};
exports.ComponentSet = ComponentSet;
//# sourceMappingURL=ComponentSet.js.map