"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Component_1 = require("./Component");
var rxjs_1 = require("rxjs");
var Instance_1 = require("./Instance");
exports.createComponent = function () {
    var subject = new rxjs_1.Subject();
    var currentNode;
    var nodeRef = {
        set current(node) {
            if (!node || node === currentNode) {
                return;
            }
            currentNode = node;
            subject.next();
        },
        get current() {
            return currentNode;
        }
    };
    var ComponentWrapper = function (props) {
        return React.createElement(Component_1.Component, __assign({}, props, { nodeRef: nodeRef }));
    };
    var InstanceWrapper = function (props) {
        var _a = React.useState(nodeRef.current), isHasComponent = _a[0], setHasComponent = _a[1];
        React.useEffect(function () {
            var subscription = subject.subscribe(function () {
                setHasComponent(true);
            });
            return subscription.unsubscribe();
        }, []);
        if (!isHasComponent) {
            return null;
        }
        return React.createElement(Instance_1.Instance, __assign({}, props, { component: nodeRef.current }));
    };
    return {
        Component: ComponentWrapper,
        Instance: InstanceWrapper
    };
};
//# sourceMappingURL=createComponent.js.map