import * as React from 'react';
import { AutoLayoutProps, BorderProps, CornerProps, DefaultContainerProps, DefaultShapeProps, FrameSpecificProps, InstanceItemProps, SelectionEventProps, StyleOf } from '../../types';
import { LayoutStyleProperties } from '../../styleTransformers/transformLayoutStyleProperties';
import { BlendStyleProperties } from '../../styleTransformers/transformBlendProperties';
import { GeometryStyleProperties } from '../../styleTransformers/transformGeometryStyleProperties';
import { YogaStyleProperties } from '../../yoga/YogaStyleProperties';
import { BorderStyleProperties } from '../../styleTransformers/transformBorderProperties';
import { OnLayoutHandlerProps } from '../../hooks/useOnLayoutHandler';
interface Preset {
    name: string;
    width: number;
    height: number;
}
export declare const FRAME_PRESETS: {
    iPhoneX: {
        name: string;
        width: number;
        height: number;
    };
    iPhone8Plus: {
        name: string;
        width: number;
        height: number;
    };
    iPhone8: {
        name: string;
        width: number;
        height: number;
    };
    iPhoneSE: {
        name: string;
        width: number;
        height: number;
    };
    googlePixel2: {
        name: string;
        width: number;
        height: number;
    };
    googlePixel2XL: {
        name: string;
        width: number;
        height: number;
    };
    android: {
        name: string;
        width: number;
        height: number;
    };
    'iPadMini/9.7': {
        name: string;
        width: number;
        height: number;
    };
    'iPadPro10.5': {
        name: string;
        width: number;
        height: number;
    };
    'iPadPro12.9': {
        name: string;
        width: number;
        height: number;
    };
    surfacePro3: {
        name: string;
        width: number;
        height: number;
    };
    surfacePro4: {
        name: string;
        width: number;
        height: number;
    };
    desktop: {
        name: string;
        width: number;
        height: number;
    };
    macbook: {
        name: string;
        width: number;
        height: number;
    };
    macbookPro: {
        name: string;
        width: number;
        height: number;
    };
    surfaceBook: {
        name: string;
        width: number;
        height: number;
    };
    iMac: {
        name: string;
        width: number;
        height: number;
    };
    appleWatch42mm: {
        name: string;
        width: number;
        height: number;
    };
    appleWatch38mm: {
        name: string;
        width: number;
        height: number;
    };
    a4: {
        name: string;
        width: number;
        height: number;
    };
    a5: {
        name: string;
        width: number;
        height: number;
    };
    a6: {
        name: string;
        width: number;
        height: number;
    };
    letter: {
        name: string;
        width: number;
        height: number;
    };
    tabloid: {
        name: string;
        width: number;
        height: number;
    };
    twitterPost: {
        name: string;
        width: number;
        height: number;
    };
    twitterHeader: {
        name: string;
        width: number;
        height: number;
    };
    facebookPost: {
        name: string;
        width: number;
        height: number;
    };
    facebookCover: {
        name: string;
        width: number;
        height: number;
    };
    instagramPost: {
        name: string;
        width: number;
        height: number;
    };
    instagramStory: {
        name: string;
        width: number;
        height: number;
    };
    dribbbleShot: {
        name: string;
        width: number;
        height: number;
    };
    dribbbleShotHD: {
        name: string;
        width: number;
        height: number;
    };
    linkedInCover: {
        name: string;
        width: number;
        height: number;
    };
};
export interface FrameNodeProps extends DefaultShapeProps, DefaultContainerProps, InstanceItemProps, SelectionEventProps, AutoLayoutProps, BorderProps, CornerProps, FrameSpecificProps, OnLayoutHandlerProps {
    style?: StyleOf<GeometryStyleProperties & YogaStyleProperties & LayoutStyleProperties & BlendStyleProperties & BorderStyleProperties>;
    preset?: Preset;
}
declare const Frame: React.FC<FrameNodeProps>;
export { Frame };
