import * as React from 'react';
import { DefaultShapeProps, BorderProps, CornerProps, StyleOf, InstanceItemProps, SelectionEventProps } from '../../types';
import { LayoutStyleProperties } from '../../styleTransformers/transformLayoutStyleProperties';
import { GeometryStyleProperties } from '../../styleTransformers/transformGeometryStyleProperties';
import { BlendStyleProperties } from '../../styleTransformers/transformBlendProperties';
import { YogaStyleProperties } from '../../yoga/YogaStyleProperties';
import { OnLayoutHandlerProps } from '../../hooks/useOnLayoutHandler';
export interface LineProps extends DefaultShapeProps, CornerProps, BorderProps, InstanceItemProps, SelectionEventProps, OnLayoutHandlerProps {
    style?: StyleOf<YogaStyleProperties & LayoutStyleProperties & GeometryStyleProperties & BlendStyleProperties>;
}
declare const Line: React.FC<LineProps>;
export { Line };
