import * as React from 'react';
import { BaseNodeProps, ChildrenProps, ExportProps, StyleOf } from '../../types';
import { YogaStyleProperties } from '../../yoga/YogaStyleProperties';
import { OnLayoutHandlerProps } from '../../hooks/useOnLayoutHandler';
export interface PageProps extends BaseNodeProps, ChildrenProps, ExportProps, OnLayoutHandlerProps {
    style?: StyleOf<YogaStyleProperties>;
    isCurrent?: boolean;
    onCurrentChange?: (isCurrent: boolean) => void;
}
export declare const useCurrentPageChange: (nodeRef: {
    current?: any;
}, callback?: void | ((isCurrent: boolean) => void), _isCurrent?: boolean) => void;
declare const Page: React.FC<PageProps>;
export { Page };
