"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var useYogaLayout_1 = require("../../hooks/useYogaLayout");
var rpc_1 = require("../../rpc");
var operators_1 = require("rxjs/operators");
var useOnLayoutHandler_1 = require("../../hooks/useOnLayoutHandler");
var useInheritStyle_1 = require("../../hooks/useInheritStyle");
exports.useCurrentPageChange = function (nodeRef, callback, _isCurrent) {
    React.useEffect(function () {
        var instance = nodeRef.current;
        var subject = rpc_1.$currentPageTempId.pipe(operators_1.map(function (message) { return message === instance.reactId; }));
        var subscription = subject.subscribe(function (value) { return callback && callback(value); });
        return function () { return subscription.unsubscribe(); };
    }, []);
    React.useEffect(function () {
        if (_isCurrent) {
            rpc_1.api.setCurrentPage(nodeRef.current);
        }
    }, [_isCurrent]);
};
var Page = function (props) {
    var nodeRef = React.useRef();
    var onCurrentChange = props.onCurrentChange, otherProps = __rest(props, ["onCurrentChange"]);
    exports.useCurrentPageChange(nodeRef, onCurrentChange, props.isCurrent);
    var yogaChildProps = useYogaLayout_1.useYogaLayout(__assign({ nodeRef: nodeRef }, otherProps));
    useOnLayoutHandler_1.useOnLayoutHandler(yogaChildProps, props);
    return (React.createElement(useInheritStyle_1.InheritStyleProvider, { style: props.style },
        React.createElement("page", __assign({}, otherProps, yogaChildProps, { innerRef: nodeRef }))));
};
exports.Page = Page;
//# sourceMappingURL=Page.js.map