"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var transformLayoutStyleProperties_1 = require("../../styleTransformers/transformLayoutStyleProperties");
var transformGeometryStyleProperties_1 = require("../../styleTransformers/transformGeometryStyleProperties");
var useYogaLayout_1 = require("../../hooks/useYogaLayout");
var transformBorderProperties_1 = require("../../styleTransformers/transformBorderProperties");
var transformBlendProperties_1 = require("../../styleTransformers/transformBlendProperties");
var __1 = require("../..");
var useSelectionChange_1 = require("../../hooks/useSelectionChange");
var transformAutoLayoutToYoga_1 = require("../../styleTransformers/transformAutoLayoutToYoga");
var useOnLayoutHandler_1 = require("../../hooks/useOnLayoutHandler");
var useImageHash_1 = require("../../hooks/useImageHash");
var Rectangle = function (props) {
    var nodeRef = React.useRef();
    useSelectionChange_1.useSelectionChange(nodeRef, props);
    var style = __assign({}, __1.StyleSheet.flatten(props.style), transformAutoLayoutToYoga_1.transformAutoLayoutToYoga(props));
    var imageHash = useImageHash_1.useImageHash(style.backgroundImage);
    var rectangleProps = __assign({}, transformLayoutStyleProperties_1.transformLayoutStyleProperties(style), transformGeometryStyleProperties_1.transformGeometryStyleProperties('fills', style, imageHash), transformBorderProperties_1.transformBorderStyleProperties(style), transformBlendProperties_1.transformBlendProperties(style), props, { style: style });
    var yogaProps = useYogaLayout_1.useYogaLayout(__assign({ nodeRef: nodeRef }, rectangleProps));
    useOnLayoutHandler_1.useOnLayoutHandler(yogaProps, props);
    return React.createElement("rectangle", __assign({}, rectangleProps, yogaProps, { innerRef: nodeRef }));
};
exports.Rectangle = Rectangle;
//# sourceMappingURL=Rectangle.js.map