import * as React from 'react';
import { DefaultShapeProps, CornerProps, StarNodeProps, StyleOf, InstanceItemProps, SelectionEventProps } from '../../types';
import { LayoutStyleProperties } from '../../styleTransformers/transformLayoutStyleProperties';
import { GeometryStyleProperties } from '../../styleTransformers/transformGeometryStyleProperties';
import { BlendStyleProperties } from '../../styleTransformers/transformBlendProperties';
import { YogaStyleProperties } from '../../yoga/YogaStyleProperties';
import { OnLayoutHandlerProps } from '../../hooks/useOnLayoutHandler';
export interface StarProps extends DefaultShapeProps, CornerProps, StarNodeProps, InstanceItemProps, SelectionEventProps, OnLayoutHandlerProps {
    style?: StyleOf<YogaStyleProperties & LayoutStyleProperties & GeometryStyleProperties & BlendStyleProperties>;
    children?: undefined;
}
declare const Star: React.FC<StarProps>;
export { Star };
