import { CommonStyle } from '../types';
import { Assign } from 'utility-types';
declare type StyleProp<P, T> = {
    [P in keyof T]: Partial<CommonStyle>;
};
export declare class StyleSheet {
    static create<T extends StyleProp<any, T>>(styles: T): T;
    static flatten<C extends Partial<CommonStyle>>(styles: C | C[] | void): C;
    static resolve<T extends {
        [key: string]: Partial<CommonStyle>;
    }>(value: T): T;
    static compose<C1 extends Partial<CommonStyle>, C2 extends Partial<CommonStyle>>(style1: C1, style2: C2): Assign<C1, C2>;
    static hairlineWidth: number;
    static absoluteFill: Partial<CommonStyle>;
    static absoluteFillObject: Partial<CommonStyle>;
}
export {};
