"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_devtools_core_1 = require("react-devtools-core");
var rpc_1 = require("../rpc");
exports.connectToDevTools = function () {
    var connectionFailed = false;
    var connection = new WebSocket('ws://localhost:8097');
    react_devtools_core_1.connectToDevTools({
        // prevents from multiple retries
        isAppActive: function () { return !connectionFailed; },
        resolveRNStyle: null,
        websocket: connection
    });
    connection.onerror = function () {
        console.warn('React DevTools is not running. Please run React DevTools or remove `connectToDevTools` call');
        connectionFailed = true;
    };
    // @ts-ignore
    window.__REACT_DEVTOOLS_GLOBAL_HOOK__.on('react-devtools', function (agent) {
        agent._bridge.addListener('inspectElement', function (data) {
            var rendererID = data.rendererID, id = data.id;
            var renderer = agent.rendererInterfaces[rendererID];
            var nodes = null;
            if (renderer !== null) {
                nodes = renderer.findNativeNodesForFiberID(id);
            }
            if (nodes !== null && nodes[0]) {
                rpc_1.api.highlightNativeElement(nodes[0]);
            }
        });
    });
};
//# sourceMappingURL=connectToDevTools.js.map