"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var usePromise = require("react-fetch-hook/usePromise");
var getImageHandler_1 = require("../helpers/getImageHandler");
exports.toDataURL = function (url) {
    return fetch(url)
        .then(function (response) { return response.blob(); })
        .then(function (blob) {
        return new Promise(function (resolve, reject) {
            var reader = new FileReader();
            // @ts-ignore
            reader.onloadend = function () { return resolve(reader.result); };
            reader.onerror = reject;
            reader.readAsDataURL(blob);
        });
    });
};
exports.useImageHash = function (source) {
    var src = source && (typeof source === 'string' ? source : 'uri' in source ? source.uri : source.default);
    var dataUrl = usePromise(function (src) { return (src && (src.slice(0, 5) === 'data:' ? Promise.resolve(src) : exports.toDataURL(src))) || Promise.resolve(null); }, src).data;
    var imageHash = usePromise(function (dataUrl) { return (dataUrl && getImageHandler_1.getImageHash(dataUrl)) || Promise.resolve(null); }, dataUrl).data;
    return imageHash;
};
//# sourceMappingURL=useImageHash.js.map