"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var rpc_1 = require("../rpc");
exports.useSelectionChange = function (nodeRef, props) {
    var didMountRef = React.useRef(false);
    var _a = React.useState(false), isSelected = _a[0], setSelected = _a[1];
    React.useEffect(function () {
        if (!props.onSelectionEnter && !props.onSelectionLeave) {
            return;
        }
        if (!didMountRef.current) {
            didMountRef.current = true;
            return;
        }
        if (isSelected) {
            props.onSelectionEnter && props.onSelectionEnter();
        }
        else {
            props.onSelectionLeave && props.onSelectionLeave();
        }
    }, [isSelected]);
    React.useEffect(function () {
        var instance = nodeRef.current;
        if (!props.onSelectionEnter && !props.onSelectionLeave) {
            return;
        }
        var handler = function (selection) {
            if (selection.indexOf(instance.reactId) >= 0) {
                setSelected(true);
            }
            else {
                setSelected(false);
            }
        };
        var subscription = rpc_1.$selectionReactIds.subscribe(function (value) { return handler && handler(value); });
        return function () { return subscription.unsubscribe(); };
    }, [props.onSelectionEnter, props.onSelectionLeave]);
};
//# sourceMappingURL=useSelectionChange.js.map