"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var operators_1 = require("rxjs/operators");
var rxjs_1 = require("rxjs");
var $setTextChildren = new rxjs_1.ReplaySubject();
exports.setTextChildren = function (node, characters) {
    $setTextChildren.next({ node: node, characters: characters });
};
exports.useTextChildren = function (nodeRef) {
    var _a = React.useState(null), textChildren = _a[0], setTextChildren = _a[1];
    React.useEffect(function () {
        var instance = nodeRef.current;
        var subject = $setTextChildren.pipe(operators_1.filter(function (message) { return message.node.reactId === instance.reactId; }), operators_1.map(function (message) { return message.characters; }));
        var subscription = subject.subscribe(setTextChildren);
        return function () { return subscription.unsubscribe(); };
    }, []);
    return textChildren;
};
//# sourceMappingURL=useTextChildren.js.map