"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.baseNodeMixin = function (node) { return function (props) {
    if (props.name) {
        node.name = props.name;
    }
    if (props.pluginData) {
        Object.keys(props.pluginData).forEach(function (key) {
            node.setPluginData(key, props.pluginData[key]);
        });
    }
    if (props.sharedPluginData) {
        Object.keys(props.sharedPluginData).forEach(function (namespace) {
            Object.keys(props.sharedPluginData[namespace]).forEach(function (key) {
                node.setSharedPluginData(namespace, key, props.pluginData[key]);
            });
        });
    }
}; };
//# sourceMappingURL=baseNodeMixin.js.map