"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var isValidSize_1 = require("../helpers/isValidSize");
exports.layoutMixin = function (node) { return function (props) {
    if (props.preventResizing) {
        return;
    }
    if (props.relativeTransform) {
        node.relativeTransform = props.relativeTransform;
    }
    if (typeof props.x === 'number') {
        node.x = props.x;
    }
    if (typeof props.y === 'number') {
        node.y = props.y;
    }
    if (typeof props.rotation === 'number') {
        node.rotation = props.rotation;
    }
    if ((isValidSize_1.isValidSize(props.width) || isValidSize_1.isValidSize(props.height)) && node.type !== 'LINE') {
        if (props.isWithoutConstraints) {
            node.resizeWithoutConstraints(props.width, props.height);
        }
        else {
            node.resize(isValidSize_1.isValidSize(props.width) ? props.width : node.width, isValidSize_1.isValidSize(props.height) ? props.height : node.height);
        }
    }
    if (isValidSize_1.isValidSize(props.width) && node.type === 'LINE') {
        if (props.isWithoutConstraints) {
            node.resizeWithoutConstraints(props.width, 0);
        }
        else {
            node.resize(props.width, 0);
        }
    }
    node.layoutAlign = props.layoutAlign || 'INHERIT';
    node.layoutGrow = props.layoutGrow || 0;
}; };
//# sourceMappingURL=layoutMixin.js.map