"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var baseNodeMixin_1 = require("../mixins/baseNodeMixin");
var layoutMixin_1 = require("../mixins/layoutMixin");
var saveStyleMixin_1 = require("../mixins/saveStyleMixin");
var exportMixin_1 = require("../mixins/exportMixin");
var blendMixin_1 = require("../mixins/blendMixin");
var frameMixin_1 = require("../mixins/frameMixin");
var autoLayoutMixin_1 = require("../mixins/autoLayoutMixin");
var cornerMixin_1 = require("../mixins/cornerMixin");
var rectangleCornerMixin_1 = require("../mixins/rectangleCornerMixin");
var geometryMixin_1 = require("../mixins/geometryMixin");
var frameSpecificMixin_1 = require("../mixins/frameSpecificMixin");
var sceneNodeMixin_1 = require("../mixins/sceneNodeMixin");
var constraintsMixin_1 = require("../mixins/constraintsMixin");
exports.component = function (node) { return function (props) {
    var componentNode = node || figma.createComponent();
    saveStyleMixin_1.saveStyleMixin(componentNode)(props);
    baseNodeMixin_1.baseNodeMixin(componentNode)(props);
    layoutMixin_1.layoutMixin(componentNode)(props);
    exportMixin_1.exportMixin(componentNode)(props);
    blendMixin_1.blendMixin(componentNode)(props);
    geometryMixin_1.geometryMixin(componentNode)(props);
    cornerMixin_1.cornerMixin(componentNode)(props);
    rectangleCornerMixin_1.rectangleCornerMixin(componentNode)(props);
    constraintsMixin_1.constraintsMixin(componentNode)(props);
    autoLayoutMixin_1.autoLayoutMixin(componentNode)(props);
    frameMixin_1.frameMixin(componentNode)(props);
    frameSpecificMixin_1.frameSpecificProps(componentNode)(props);
    sceneNodeMixin_1.sceneNodeMixin(componentNode)(props);
    return componentNode;
}; };
//# sourceMappingURL=component.js.map