"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var layoutMixin_1 = require("../mixins/layoutMixin");
var saveStyleMixin_1 = require("../mixins/saveStyleMixin");
var baseNodeMixin_1 = require("../mixins/baseNodeMixin");
var exportMixin_1 = require("../mixins/exportMixin");
var blendMixin_1 = require("../mixins/blendMixin");
var frameMixin_1 = require("../mixins/frameMixin");
var sceneNodeMixin_1 = require("../mixins/sceneNodeMixin");
var createNewComponentSet = function () {
    var component = figma.createComponent();
    component.setPluginData('isComponentStubElement', 'true');
    return figma.combineAsVariants([component], figma.currentPage);
};
exports.componentset = function (node) { return function (props) {
    var componentSetNode = node || props.node || createNewComponentSet();
    saveStyleMixin_1.saveStyleMixin(componentSetNode)(props);
    baseNodeMixin_1.baseNodeMixin(componentSetNode)(props);
    layoutMixin_1.layoutMixin(componentSetNode)(props);
    exportMixin_1.exportMixin(componentSetNode)(props);
    blendMixin_1.blendMixin(componentSetNode)(props);
    frameMixin_1.frameMixin(componentSetNode)(props);
    sceneNodeMixin_1.sceneNodeMixin(componentSetNode)(props);
    return componentSetNode;
}; };
//# sourceMappingURL=componentset.js.map