"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var baseNodeMixin_1 = require("../mixins/baseNodeMixin");
var layoutMixin_1 = require("../mixins/layoutMixin");
var geometryMixin_1 = require("../mixins/geometryMixin");
var cornerMixin_1 = require("../mixins/cornerMixin");
var exportMixin_1 = require("../mixins/exportMixin");
var blendMixin_1 = require("../mixins/blendMixin");
var propsAssign_1 = require("../helpers/propsAssign");
var sceneNodeMixin_1 = require("../mixins/sceneNodeMixin");
var constraintsMixin_1 = require("../mixins/constraintsMixin");
var ellipseNodePropsAssign = propsAssign_1.propsAssign(['arcData']);
exports.ellipse = function (node) { return function (props) {
    var ellipseNode = node || props.node || figma.createEllipse();
    baseNodeMixin_1.baseNodeMixin(ellipseNode)(props);
    layoutMixin_1.layoutMixin(ellipseNode)(props);
    geometryMixin_1.geometryMixin(ellipseNode)(props);
    exportMixin_1.exportMixin(ellipseNode)(props);
    cornerMixin_1.cornerMixin(ellipseNode)(props);
    blendMixin_1.blendMixin(ellipseNode)(props);
    sceneNodeMixin_1.sceneNodeMixin(ellipseNode)(props);
    constraintsMixin_1.constraintsMixin(ellipseNode)(props);
    ellipseNodePropsAssign(ellipseNode)(props);
    return ellipseNode;
}; };
//# sourceMappingURL=ellipse.js.map