"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var baseNodeMixin_1 = require("../mixins/baseNodeMixin");
var layoutMixin_1 = require("../mixins/layoutMixin");
var saveStyleMixin_1 = require("../mixins/saveStyleMixin");
var exportMixin_1 = require("../mixins/exportMixin");
var blendMixin_1 = require("../mixins/blendMixin");
var frameMixin_1 = require("../mixins/frameMixin");
var autoLayoutMixin_1 = require("../mixins/autoLayoutMixin");
var cornerMixin_1 = require("../mixins/cornerMixin");
var rectangleCornerMixin_1 = require("../mixins/rectangleCornerMixin");
var geometryMixin_1 = require("../mixins/geometryMixin");
var frameSpecificMixin_1 = require("../mixins/frameSpecificMixin");
var sceneNodeMixin_1 = require("../mixins/sceneNodeMixin");
var constraintsMixin_1 = require("../mixins/constraintsMixin");
exports.frame = function (node) { return function (props) {
    var frameNode = node || props.node || figma.createFrame();
    saveStyleMixin_1.saveStyleMixin(frameNode)(props);
    baseNodeMixin_1.baseNodeMixin(frameNode)(props);
    layoutMixin_1.layoutMixin(frameNode)(props);
    exportMixin_1.exportMixin(frameNode)(props);
    blendMixin_1.blendMixin(frameNode)(props);
    geometryMixin_1.geometryMixin(frameNode)(props);
    cornerMixin_1.cornerMixin(frameNode)(props);
    rectangleCornerMixin_1.rectangleCornerMixin(frameNode)(props);
    constraintsMixin_1.constraintsMixin(frameNode)(props);
    autoLayoutMixin_1.autoLayoutMixin(frameNode)(props);
    frameMixin_1.frameMixin(frameNode)(props);
    frameSpecificMixin_1.frameSpecificProps(frameNode)(props);
    sceneNodeMixin_1.sceneNodeMixin(frameNode)(props);
    return frameNode;
}; };
//# sourceMappingURL=frame.js.map