"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var baseNodeMixin_1 = require("../mixins/baseNodeMixin");
var layoutMixin_1 = require("../mixins/layoutMixin");
var geometryMixin_1 = require("../mixins/geometryMixin");
var saveStyleMixin_1 = require("../mixins/saveStyleMixin");
var cornerMixin_1 = require("../mixins/cornerMixin");
var exportMixin_1 = require("../mixins/exportMixin");
var blendMixin_1 = require("../mixins/blendMixin");
var rectangleCornerMixin_1 = require("../mixins/rectangleCornerMixin");
var sceneNodeMixin_1 = require("../mixins/sceneNodeMixin");
var constraintsMixin_1 = require("../mixins/constraintsMixin");
exports.rectangle = function (node) { return function (props) {
    var rect = node || props.node || figma.createRectangle();
    baseNodeMixin_1.baseNodeMixin(rect)(props);
    saveStyleMixin_1.saveStyleMixin(rect)(props);
    layoutMixin_1.layoutMixin(rect)(props);
    geometryMixin_1.geometryMixin(rect)(props);
    cornerMixin_1.cornerMixin(rect)(props);
    rectangleCornerMixin_1.rectangleCornerMixin(rect)(props);
    exportMixin_1.exportMixin(rect)(props);
    blendMixin_1.blendMixin(rect)(props);
    sceneNodeMixin_1.sceneNodeMixin(rect)(props);
    constraintsMixin_1.constraintsMixin(rect)(props);
    return rect;
}; };
//# sourceMappingURL=rectangle.js.map