"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var baseNodeMixin_1 = require("../mixins/baseNodeMixin");
var layoutMixin_1 = require("../mixins/layoutMixin");
var geometryMixin_1 = require("../mixins/geometryMixin");
var saveStyleMixin_1 = require("../mixins/saveStyleMixin");
var cornerMixin_1 = require("../mixins/cornerMixin");
var exportMixin_1 = require("../mixins/exportMixin");
var blendMixin_1 = require("../mixins/blendMixin");
var propsAssign_1 = require("../helpers/propsAssign");
var sceneNodeMixin_1 = require("../mixins/sceneNodeMixin");
var constraintsMixin_1 = require("../mixins/constraintsMixin");
var vectorNodePropsAssign = propsAssign_1.propsAssign([
    'vectorPaths',
    'vectorNetwork',
    'handleMirroring'
]);
exports.vector = function (node) { return function (props) {
    var vectorNode = node || props.node || figma.createVector();
    baseNodeMixin_1.baseNodeMixin(vectorNode)(props);
    saveStyleMixin_1.saveStyleMixin(vectorNode)(props);
    layoutMixin_1.layoutMixin(vectorNode)(props);
    geometryMixin_1.geometryMixin(vectorNode)(props);
    cornerMixin_1.cornerMixin(vectorNode)(props);
    exportMixin_1.exportMixin(vectorNode)(props);
    blendMixin_1.blendMixin(vectorNode)(props);
    vectorNodePropsAssign(vectorNode)(props);
    sceneNodeMixin_1.sceneNodeMixin(vectorNode)(props);
    constraintsMixin_1.constraintsMixin(vectorNode)(props);
    return vectorNode;
}; };
//# sourceMappingURL=vector.js.map