"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var capitalize = function (w) {
    return w[0].toUpperCase() + w.substr(1).toLowerCase();
};
var numberToWeightMapping = {
    '100': 'Thin',
    '200': 'ExtraLight',
    '300': 'Light',
    '400': 'Regular',
    '500': 'Medium',
    '600': 'SemiBold',
    '700': 'Bold',
    '800': 'ExtraBold',
    '900': 'Black',
    '950': 'ExtraBlack'
};
var transformFontWeight = function (fontWeight) {
    if ("" + parseInt(fontWeight) === "" + fontWeight) {
        return numberToWeightMapping["" + fontWeight];
    }
    else {
        return capitalize(fontWeight);
    }
};
exports.convertFontStyle = function (fontWeight, fontStyle) {
    if (fontWeight === void 0) { fontWeight = 'normal'; }
    if (fontStyle === void 0) { fontStyle = 'normal'; }
    if (fontStyle === 'normal') {
        return fontWeight === 'normal' ? 'Regular' : transformFontWeight(fontWeight);
    }
    else if (fontWeight === 'normal') {
        return capitalize(fontStyle);
    }
    else {
        return transformFontWeight(fontWeight) + " " + capitalize(fontStyle);
    }
};
//# sourceMappingURL=converFontStyle.js.map