import { BlendProps, Color } from '../types';
export declare type CSSBlendMode = 'normal' | 'multiply' | 'screen' | 'overlay' | 'darken' | 'lighten' | 'color-dodge' | 'color-burn' | 'hard-light' | 'soft-light' | 'difference' | 'exclusion' | 'hue' | 'saturation' | 'color' | 'luminosity';
export interface BlendStyleProperties {
    opacity: number;
    blendMode: CSSBlendMode;
    shadowColor: Color;
    shadowOffset: {
        width: number;
        height: number;
    };
    shadowOpacity: number;
    shadowRadius: number;
}
export declare const transformBlendProperties: (styles?: Partial<BlendStyleProperties>) => BlendProps;
