"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var transformShadowToEffect_1 = require("./transformShadowToEffect");
var transofrmBlendMode = function (cssBlendMode) {
    /**
     * TODO: Missing modes - PASS_THROUGH, LINEAR_BURN, LINEAR_DODGE
     */
    switch (cssBlendMode) {
        case 'normal':
            return 'NORMAL';
        case 'darken':
            return 'DARKEN';
        case 'multiply':
            return 'MULTIPLY';
        case 'color-burn':
            return 'COLOR_BURN';
        case 'lighten':
            return 'LIGHTEN';
        case 'screen':
            return 'SCREEN';
        case 'color-dodge':
            return 'COLOR_DODGE';
        case 'overlay':
            return 'OVERLAY';
        case 'soft-light':
            return 'SOFT_LIGHT';
        case 'hard-light':
            return 'HARD_LIGHT';
        case 'difference':
            return 'DIFFERENCE';
        case 'exclusion':
            return 'EXCLUSION';
        case 'hue':
            return 'HUE';
        case 'saturation':
            return 'SATURATION';
        case 'color':
            return 'COLOR';
        case 'luminosity':
            return 'LUMINOSITY';
        default:
            break;
    }
};
exports.transformBlendProperties = function (styles) {
    if (!styles) {
        return {};
    }
    var blendProps = {};
    if (styles.opacity) {
        blendProps.opacity = styles.opacity;
    }
    if (styles.blendMode) {
        blendProps.blendMode = transofrmBlendMode(styles.blendMode);
    }
    if (styles.shadowColor) {
        blendProps.effects = [transformShadowToEffect_1.transformShadowToEffect(styles)];
    }
    return blendProps;
};
//# sourceMappingURL=transformBlendProperties.js.map