"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var size_1 = require("../helpers/size");
var transformColors_1 = require("./transformColors");
exports.transformBorderStyleProperties = function (styles) {
    if (!styles) {
        return {};
    }
    var props = {};
    if (styles.borderRadius) {
        props.cornerRadius = size_1.transformSize(styles.borderRadius);
    }
    if (styles.borderTopLeftRadius) {
        props.topLeftRadius = size_1.transformSize(styles.borderTopLeftRadius);
    }
    if (styles.borderTopRightRadius) {
        props.topRightRadius = size_1.transformSize(styles.borderTopRightRadius);
    }
    if (styles.borderBottomLeftRadius) {
        props.bottomLeftRadius = size_1.transformSize(styles.borderBottomLeftRadius);
    }
    if (styles.borderBottomRightRadius) {
        props.bottomRightRadius = size_1.transformSize(styles.borderBottomRightRadius);
    }
    if (styles.borderColor) {
        props.strokes = [transformColors_1.colorToPaint(styles.borderColor)];
    }
    if (styles.borderWidth) {
        props.strokeWeight = size_1.transformSize(styles.borderWidth);
    }
    return props;
};
//# sourceMappingURL=transformBorderProperties.js.map