import { Color, GeometryProps, TextNodeProps } from '../types';
export interface TextStyleProperties {
    color: string;
    fontFamily: string;
    fontWeight: 'normal' | 'bold' | '100' | '200' | '300' | '400' | '500' | '600' | '700' | '800' | '900';
    fontStyle: 'normal' | 'italic' | 'solid';
    fontSize: number;
    textAlign: 'auto' | 'left' | 'right' | 'center' | 'justify';
    lineHeight: number | string;
    letterSpacing: number | string;
    textDecorationLine: 'none' | 'underline' | 'line-through';
    textShadowColor: Color;
    textShadowOffset: {
        width: number;
        height: number;
    };
    textShadowRadius: number;
    textStyleId: string;
}
interface TextProperties extends GeometryProps, TextNodeProps {
}
export declare const transformTextStyleProperties: (style?: Partial<TextStyleProperties>) => TextProperties;
export {};
